<?php

/**
 * Description of NicEdit
 *
 * @author K. O. Frimpong
 */
class NicEdit extends JsInputWidget {

    /**
     *
     * @var boolean Whether an HTML label should be rendered 
     */
    public $renderLabel = true;

    public function run() {
        list($name, $id) = $this->resolveNameID();

        if (isset($this->htmlOptions['id']))
            $id = $this->htmlOptions['id'];
        else
            $this->htmlOptions['id'] = $id;
        if (isset($this->htmlOptions['name']))
            $name = $this->htmlOptions['name'];
        else
            $this->htmlOptions['name'] = $name;

        if ($this->hasModel()) {
            if ($this->renderLabel) {
                echo CHtml::activeLabelEx($this->model, $this->attribute);
            }
            echo CHtml::activeTextArea($this->model, $this->attribute, $this->htmlOptions);
        }
        else {
            if ($this->renderLabel) {
                echo CHtml::label($name, $id);
            }
            echo CHtml::textArea($name, $this->value, $this->htmlOptions) . "\n";
        }
        $this->registerCorescript();
    }

    private function registerCorescript(){
        $id = $this->htmlOptions['id'];
        $basedir = dirname(__FILE__) . '/widgetfiles';
        $baseUrl = Yii::app()->getAssetManager()->publish($basedir);
        if(!isset($this->options['iconsPath'])){
            $this->options['iconsPath'] = $baseUrl . '/images/nicEditorIcons.gif';
        }
        $options = CJavaScript::encode($this->options);
        $script = "
            bkLib.onDomLoaded(function() {
                new nicEditor($options).panelInstance('$id');
                jQuery('#$id').closest('form').submit(function(){nicEditors.findEditor('$id').saveContent();});
            })
           ";
        Yii::app()->getClientScript()->registerScript("nic_$id", $script, CClientScript::POS_HEAD);
        Yii::app()->getClientScript()->registerScriptFile($baseUrl . '/js/nicEdit.js');
    }

}

